#include <bits/stdc++.h>
using namespace std;

#define mod 998244353

long long n, m, c;
long long b[100005];
long long a[500005];

long long power(long long a, long long b)
{
    if(b == 0){
        return 1;
    }

    long long x = power(a, b / 2);
    x *= x; x %= mod;
    if(b % 2){x *= a;}

    return x % mod;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        cin >> b[i];
    }
    cin >> c;

    for(int i = 1; i <= n; ++i){
        a[i] = i;
    }

    for(int i = 0; i <= n - m; ++i){
        for(int j = 1; j <= m; ++j){
            a[i + b[j]] = a[i + j];
        }
    }

    long long res = 0;
    for(int i = 1; i <= n; ++i){
        res += power(c, i) * a[i] % mod;
        if(res > mod){res -= mod;}
    }

    cout << res << "\n";

    return 0;
}